Summary: Performance Application Programming Interface
Name:    papi
Version: 7.1.0
Release: 2%{?dist}
License: BSD
URL:     http://icl.cs.utk.edu/papi/
Source0: http://icl.cs.utk.edu/projects/papi/downloads/%{name}-%{version}.tar.gz

Patch3000: papi-python3.patch
Patch3001: papi-nostatic.patch

Patch4001: 0001-papi-7.1.0-add-loongarch-support.patch

BuildRequires: make autoconf doxygen
BuildRequires: ncurses-devel gcc-gfortran kernel-headers chrpath
BuildRequires: lm_sensors-devel libpfm-devel pcp-libs-devel perl-generators
BuildRequires: libpfm-static net-tools rdma-core-devel infiniband-diags-devel
Requires: papi-libs = %{version}-%{release}

%description
PAPI provides a programmer interface to monitor the performance of running programs.

%package libs
Summary: Libraries for PAPI clients

%description libs
This package contains the run-time libraries for any application that wishes to use PAPI.

%package devel
Summary: Header files for the compiling programs with PAPI
Requires: papi = %{version}-%{release}
Requires: papi-libs = %{version}-%{release}
Requires: pkgconfig

%description devel
PAPI-devel includes the C header files that specify the PAPI user-space libraries and interfaces.
This is required for rebuilding any program that uses PAPI.

%package testsuite
Summary: Set of tests for checking PAPI functionality
Requires: papi = %{version}-%{release}
Requires: papi-libs = %{version}-%{release}

%description testsuite
PAPI-testsuite includes compiled versions of papi tests to ensure that PAPI functions on particular
hardware.

%package static
Summary: Static libraries for the compiling programs with PAPI
Requires: papi = %{version}-%{release}

%description static
PAPI-static includes the static versions of the library files for the PAPI user-space libraries and
interfaces.

%prep
%autosetup -n %{name}-%{version} -p1

%build
%define _lto_cflags %{nil}

export PAPI_INFINIBAND_UMAD_ROOT=/usr
export PAPI_LMSENSORS_ROOT=/usr
export PAPI_PCP_ROOT=/usr

cd src
autoconf
%configure \
    --with-perf-events \
    --with-pfm-incdir=%{_includedir} \
    --with-pfm-libdir=%{_libdir} \
    --with-static-lib=yes \
    --with-shared-lib=yes \
    --with-shlib \
    --with-shlib-tools \
    --with-components="appio coretemp example infiniband lmsensors lustre micpower mx net pcp rapl stealtime"
DBG="" %make_build

pushd ../doc
DBG="" make
DBG="" make install
popd

%install
rm -rf %{buildroot}
cd src
make DESTDIR=%{buildroot} LDCONFIG=/bin/true install-all

find %{buildroot} -type f -executable ! -iname "*.py" ! -iname "*.sh" | xargs chrpath --delete

%files
%license LICENSE.txt
%doc INSTALL.txt README.md RELEASENOTES.txt
%dir %{_datadir}/papi
%{_datadir}/papi/papi_events.csv
%{_bindir}/*
%doc %{_mandir}/man1/*

%files libs
%license LICENSE.txt
%doc INSTALL.txt README.md RELEASENOTES.txt
%{_libdir}/*.so.*

%files devel
%{_includedir}/*.h
%{_includedir}/*.hpp
%{_libdir}/*.so
%{_libdir}/pkgconfig/papi*.pc
%doc %{_mandir}/man3/*

%files testsuite
%{_datadir}/papi/run_tests*
%{_datadir}/papi/ctests
%{_datadir}/papi/ftests
%{_datadir}/papi/validation_tests
%{_datadir}/papi/components
%{_datadir}/papi/testlib

%files static
%{_libdir}/*.a

%changelog
* Wed Mar 20 2024 Huang Yang <huangyang@loongson.cn> - 7.1.0-2
- add loongarch support

* Wed Jan 10 2024 wynnfeng <wynnfeng@tencent.com> - 7.1.0-1
- Upgrade to version 7.1.0

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 6.0.0-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 6.0.0-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 6.0.0-2
- Rebuilt for OpenCloudOS Stream 23

* Wed Mar 8 2023 Shuo Wang <abushwang@tencent.com> - 6.0.0-1
- initial build
